create table if not exists square.t_hierarchy(
  lastchange timestamp default current_timestamp,
  key_element int generated by default as identity not null,
  fk_parent_element integer,
  dn text not null,
  unique_name text not null,
  fk_lang integer,
  stage enum_stage default 'stage.dev_test',
  public boolean default false not null,
  fk_privilege integer,
  quality enum_quality,
  name text,
  order_nr integer,
  short_name text,
  completeness enum_completeness,
  constraint pk_hierarchy primary key (key_element),
  constraint uk_hierarchy_dn unique (dn),
  constraint uk_hierarchy_un unique (unique_name),
  constraint fk_hierarchy_parent foreign key (fk_parent_element) references square.t_hierarchy(key_element),
  constraint fk_hierarchy_lang foreign key (fk_lang) references square.t_languagekey(pk),
  constraint fk_hierarchy_privilege foreign key (fk_privilege) references square.t_privilege(pk)
);

create index idx_hierarchy_parent on square.t_hierarchy(fk_parent_element);

comment on column square.t_hierarchy.key_element is 'unique element id';
comment on column square.t_hierarchy.fk_parent_element is 'reference to element id of parent element';
comment on column square.t_hierarchy.dn is 'unique birth name of this element';
comment on column square.t_hierarchy.fk_lang is 'reference to language key';
comment on column square.t_hierarchy.stage is 'stage of element';
comment on column square.t_hierarchy.public is 'public state';
comment on column square.t_hierarchy.fk_privilege is 'privilege for this key';
comment on column square.t_hierarchy.quality is 'quality of element';
comment on column square.t_hierarchy.name is 'name of variable';
comment on column square.t_hierarchy.order_nr is 'order in hierarchy on same level';
comment on column square.t_hierarchy.short_name is 'short name of element';
comment on column square.t_hierarchy.completeness is 'completeness of data cleanup';

grant select,insert,update,delete on square.t_hierarchy to interface_square;

